diff a/src/hotspot/share/oops/markWord.cpp b/src/hotspot/share/oops/markWord.cpp
--- a/src/hotspot/share/oops/markWord.cpp
+++ b/src/hotspot/share/oops/markWord.cpp
@@ -97,5 +97,19 @@
       st->print("??");
     }
     st->print(" age=%d)", age());
   }
 }
+
+markWord markWord::flat_array_prototype(LayoutKind lk) {
+  switch(lk) {
+    case LayoutKind::ATOMIC_FLAT:
+    case LayoutKind::NON_ATOMIC_FLAT:
+      return markWord(null_free_flat_array_pattern);
+      break;
+    case LayoutKind::NULLABLE_ATOMIC_FLAT:
+      return markWord(nullable_flat_array_pattern);
+      break;
+    default:
+      ShouldNotReachHere();
+  }
+}
